#pragma once

namespace AudioFilterDemo
{
    class FixedBufferOscillator
    {
    private:
        static const int BASE_FREQ = 20;
        IXAudio2SourceVoice * pSourceVoice;

    protected:
        static const int BUFFER_LENGTH = (48000 / BASE_FREQ);
        float waveformBuffer[BUFFER_LENGTH];

    public:
        FixedBufferOscillator(IXAudio2* pXAudio2);
        void SetFrequency(float freq);
        void SetAmplitude(float amp);
        IXAudio2SourceVoice * GetVoice();
    };
}

