#include "pch.h"
#include "IndexToPitchConverter.h"

using namespace AudioFilterDemo;

using namespace Platform;
using namespace Windows::Foundation;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Interop;

Object^ IndexToPitchConverter::Convert(Object^ value, TypeName targetType, Object^ parameter, String^ language)
{
    static wchar_t * notes[] = { L"C", L"C#", L"D", L"D#", L"E", L"F", L"F#", L"G", L"G#", L"A", L"A#", L"B" };

    double dIndex = (double)value;
    int index = (int)dIndex;
    int tenths = int(10 * (dIndex - index) + 0.5);
    double freq = 440 * pow(2, (dIndex - 69) / 12);
    wchar_t result[32];

    if (tenths == 0)
        swprintf(result, 32, L"%s %i\r\n%.1f Hz", notes[index % 12], index / 12 - 1, freq);
    else
        swprintf(result, 32, L"%s %i %i0\r\n%.1f Hz", notes[index % 12], index / 12 - 1, tenths, freq);

    return ref new String(result);
}

Object^ IndexToPitchConverter::ConvertBack(Object^ value, TypeName targetType, Object^ parameter, String^ language)
{
	return value;
}
