﻿//
// MainPage.xaml.h
// Declaration of the MainPage class.
//

#pragma once

#include "MainPage.g.h"
#include "SawtoothOscillator.h"
#include "SquareWaveOscillator.h"
#include "SineWaveOscillator.h"
#include "IndexToPitchConverter.h"

namespace AudioFilterDemo
{
    public ref class MainPage sealed
    {
    private:
        Microsoft::WRL::ComPtr<IXAudio2> pXAudio2;
        IXAudio2MasteringVoice * pMasteringVoice;
        SineWaveOscillator * pSineWaveOscillator;
        SquareWaveOscillator * pSquareWaveOscillator;
        SawtoothOscillator * pSawtoothOscillator;
        int currentFilterType;

    public:
        MainPage();

    private:
        void OnSineWaveFrequencySliderChanged(Platform::Object^ sender, Windows::UI::Xaml::Controls::Primitives::RangeBaseValueChangedEventArgs^ args);
        void OnSineWaveVolumeSliderChanged(Platform::Object^ sender, Windows::UI::Xaml::Controls::Primitives::RangeBaseValueChangedEventArgs^ args);

        void OnSquareWaveFrequencySliderChanged(Platform::Object^ sender, Windows::UI::Xaml::Controls::Primitives::RangeBaseValueChangedEventArgs^ args);
        void OnSquareWaveVolumeSliderChanged(Platform::Object^ sender, Windows::UI::Xaml::Controls::Primitives::RangeBaseValueChangedEventArgs^ args);

        void OnSawtoothFrequencySliderChanged(Platform::Object^ sender, Windows::UI::Xaml::Controls::Primitives::RangeBaseValueChangedEventArgs^ args);
        void OnSawtoothVolumeSliderChanged(Platform::Object^ sender, Windows::UI::Xaml::Controls::Primitives::RangeBaseValueChangedEventArgs^ args);

        void OnFilterTypeRadioButtonChecked(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ args);
        void OnFilterSliderChanged(Platform::Object^ sender, Windows::UI::Xaml::Controls::Primitives::RangeBaseValueChangedEventArgs^ args);
        void SetFilterParameters();

        void OnTimerTick(Platform::Object^ sender, Platform::Object^ args);
    };
}
