﻿//
// MainPage.xaml.h
// Declaration of the MainPage class.
//

#pragma once

#include "MainPage.g.h"
#include "AudioFilePlayer.h"

namespace GraphicEqualizer
{
	public ref class MainPage sealed
	{
    private:
        Microsoft::WRL::ComPtr<IXAudio2> pXAudio2;
        IXAudio2SubmixVoice * pSourceVoiceOutput;
        IXAudio2SubmixVoice * pEqualizerInput;
        IXAudio2SubmixVoice ** pEqualizerBands;
        IXAudio2MasteringVoice * pMasteringVoice;

        AudioFilePlayer * pAudioFilePlayer;

    public:
        MainPage();

    private:
        void OnOpenButtonClick(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ args);
        void OnPlayButtonClick(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ args);
        void OnPauseButtonClick(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ args);
        void OnVolumeSliderValueChanged(Platform::Object^ sender, Windows::UI::Xaml::Controls::Primitives::RangeBaseValueChangedEventArgs^ args);

        void OnEqualizerInOutButtonClick(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ args);
        void AttachSourceVoiceToEqualizer();

        void OnEqualizerSliderChanged(Platform::Object^ sender, Windows::UI::Xaml::Controls::Primitives::RangeBaseValueChangedEventArgs^ args);
    };
}
